/* Daylighting Visualization Slider */

// # of images here:
int maxImages = 26;
int imageIndex = 0;

PImage[] images = new PImage[maxImages];
PImage[] diagram = new PImage[maxImages];

String time[];

HScrollbar Hslider;

//Image size + y22
void setup() {
  size(800,600);
  noStroke();
  

  color sliderColor = color(#f2f2f2);

//Change CSV as needed:
  time = loadStrings("630to20.csv");


//Update image file name:  
  for (int i = 0; i < images.length; i++) {
    images[i] = loadImage( "PFL_1221_" + nf(i, 2) + ".jpg" );   
  }
  
  for (int i = 0; i < images.length; i++) {
    diagram[i] = loadImage( "PFL_sunpath_1221_" + nf(i, 2) + ".jpg" );   
  }

Hslider = new HScrollbar(30, height-40, 500, 20, 1, maxImages-1, sliderColor);
Hslider.setValue(0);
}
    

void draw() {
  background(20);
  
  image(images[Hslider.value()], 0, 0, 800, 600);
  
  image(diagram[Hslider.value()], width-195, height-152, 300*.6, 244.5*.6);
  
  fill(255);
  text(time[Hslider.value()], 540, height-36);
  
  //FIle name:
  text("Princeton Firestone Library [Winter Solstice]", 30, height-60); //text for images3
  
Hslider.update();
Hslider.display();
  
    }

class HScrollbar {
  int swidth, sheight;    // width and height of bar
  float xpos, ypos;       // x and y position of bar
  float spos, newspos;    // x position of slider
  float sposMin, sposMax; // max and min values of slider
  int loose;              // how loose/heavy
  boolean over;           // is the mouse over the slider?
  boolean locked;
  float ratio;
  int step;
  color barcol;

  HScrollbar (float xp, float yp, int sw, int sh, int l, int st, color colbac) {
    swidth = sw;
    sheight = sh;
    int widthtoheight = sw - sh;
    ratio = (float)sw / (float)widthtoheight;
    xpos = xp;
    ypos = yp-sheight/2;
    spos = xpos + swidth/2 - sheight/2;
    newspos = spos;
    sposMin = xpos;
    sposMax = xpos + swidth - sheight;
    loose = l;
    step = st;
    barcol = colbac;
  }

  void update() {
    if (overEvent()) {
      over = true;
    } else {
      over = false;
    }
    if (mousePressed && over) {
      locked = true;
    }
    if (!mousePressed) {
      locked = false;
    }
    if (locked) {
      newspos = constrain(mouseX-sheight/2, sposMin, sposMax);
    }
    if (abs(newspos - spos) > 1) {
      spos = spos + (newspos-spos)/loose;
    }
  }

  float constrain(float val, float minv, float maxv) {
    return min(max(val, minv), maxv);
  }

  boolean overEvent() {
    if (mouseX > xpos && mouseX < xpos+swidth &&
       mouseY > ypos && mouseY < ypos+sheight) {
      return true;
    } else {
      return false;
    }
  }

  void display() {
    noStroke();
    fill(barcol);
    rect(xpos, ypos, swidth, sheight);
    if (over || locked) {
      fill(#efb22d);
    } else {
      fill(102, 102, 102);
    }
    rect(spos, ypos, sheight, sheight);
  }

  float getPos() {
    // Convert spos to be values between
    // 0 and the total width of the scrollbar
    return spos * ratio;
  }
  
  int value() {
    // Convert slider position Spos to a value between 0 and 1
    return round((spos-xpos) / (swidth-sheight) * step);
  }
  
  void setValue(float value)
  {
    // convert a value (0 to 1) to slider position
    if (value<0) value=0;
    if (value>1) value=1;
    spos = xpos + ((swidth-sheight)*value);
    newspos = spos;
  }
}


